/*****************************************************************************
 *              D: a minimal compiler for educational purpose                *
 ***************************************************************************** 
 *                                                                           *
 * Copyright (c) 2009 Christophe Alias                                       *
 *                                                                           *
 * This program is free software; you can redistribute it and/or modify it   *
 * under the terms of the GNU General Public License as published by the     *
 * Free Software Foundation; either version 2 of the License, or (at your    * 
 * option) any later version.                                                *
 *                                                                           *
 * This program is distributed in the hope that it will be useful, but       *
 * WITHOUT ANY WARRANTY; without even the implied warranty of                *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General  *
 * Public License for more details.                                          *
 *                                                                           *
 * You should have received a copy of the GNU General Public License along   *
 * with this program; if not, write to the Free Software Foundation, Inc.,   *
 * 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.                 *
 *                                                                           *
 * Written by Christophe Alias, Christophe.Alias@ens-lyon.fr                 *
 *                                                                           *
 *****************************************************************************/
#include "code_generation.h"
#include <stdio.h>

//void emit(char* s) { printf("  %s\n",s); }

void add(char* result_reg, char* op1_reg, char* op2_reg)
{
  printf("  ADD %s,%s\n",op1_reg,op2_reg);
  printf("  MOV %s,%s\n",result_reg,op1_reg);
}

void sub(char* result_reg, char* op1_reg, char* op2_reg)
{
  printf("  SUB %s,%s\n",op1_reg,op2_reg);
  printf("  MOV %s,%s\n",result_reg,op1_reg);
}

void mul(char* result_reg, char* op1_reg, char* op2_reg)
{
  printf("  MUL %s\t\t# %s must be AX\n",op2_reg,op1_reg);
  printf("  MOV %s,%s\n",result_reg,op1_reg); //op1_reg must be AX
}

void move_int(char* target_reg, int value)
{
  printf("  MOV %s,%d\n",target_reg,value);
}

void move_reg(char* target_reg, char* source_reg)
{
  printf("  MOV %s,%s\n",target_reg,source_reg);
}

void load(char* target_reg, char* mem)
{
  printf("  MOV %s,%s\n",target_reg,mem);
}

void store(char* mem, char* source_reg)
{
  printf("  MOV %s,%s\n",mem,source_reg);
}

void push(char* reg)
{
  printf("  PUSH %s\n",reg);
}

void cmp_g(char* result_reg, char* op1_reg, char* op2_reg)
{
  printf("  CMP %s,%s\n",op1_reg,op2_reg);
  printf("  SETG %s\n",result_reg);
}

void cmp_eq(char* result_reg, char* op1_reg, char* op2_reg)
{
  printf("  CMP %s,%s\n",op1_reg,op2_reg);
  printf("  SETE %s\n",result_reg);
}

void cmp_neq(char* result_reg, char* op1_reg, char* op2_reg)
{
  printf("  CMP %s,%s\n",op1_reg,op2_reg);
  printf("  SETNE %s\n",result_reg);
}

/* print "label: "  */ void lbl         (char* label) { printf("%s:\n",label); }

/* goto label       */ void jmp_lbl     (char* label) { printf("  JMP %s\n",label); }

/*if !reg goto label */ void jmp_if_false(char* reg, char* label)    
{ printf("  CMP %s,1\n",reg); printf("  JNE %s\n",label); }

/* call function    */ void call        (char* function)   { printf("  CALL %s\n",function); }


void emit_prelude(int nb_local_vars)
{
  printf("  PUSH BP\n"); 
  printf("  MOV BP,SP\n"); 
  printf("  SUB SP,%d\n",nb_local_vars*INT_SIZE);
  emit_load(); //stack -> registers
}

void emit_postlude(int nb_arguments, int nb_local_vars)
{
  printf("  ADD SP,%d\n",nb_local_vars*INT_SIZE);
  printf("  POP BP\n"); 
  printf("  RET %d\n",nb_arguments*INT_SIZE);
}
