/*****************************************************************************
 *              D: a minimal compiler for educational purpose                *
 ***************************************************************************** 
 *                                                                           *
 * Copyright (c) 2009 Christophe Alias                                       *
 *                                                                           *
 * This program is free software; you can redistribute it and/or modify it   *
 * under the terms of the GNU General Public License as published by the     *
 * Free Software Foundation; either version 2 of the License, or (at your    * 
 * option) any later version.                                                *
 *                                                                           *
 * This program is distributed in the hope that it will be useful, but       *
 * WITHOUT ANY WARRANTY; without even the implied warranty of                *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General  *
 * Public License for more details.                                          *
 *                                                                           *
 * You should have received a copy of the GNU General Public License along   *
 * with this program; if not, write to the Free Software Foundation, Inc.,   *
 * 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.                 *
 *                                                                           *
 * Written by Christophe Alias, Christophe.Alias@ens-lyon.fr                 *
 *                                                                           *
 *****************************************************************************/
#ifndef __CODE_GENERATION_H
#define __CODE_GENERATION_H

#define INT_SIZE 2
#define POINTER_SIZE 4
//in bytes
#define UNREF_NEG "WORD PTR[BP-%d]"
#define UNREF_POS "WORD PTR[BP+%d]"
//access to integer local variables and arguments
#define RETURN_REGISTER "r_return"

//void emit(char* s);

void add(char* result_reg, char* op1_reg, char* op2_reg);
void sub(char* result_reg, char* op1_reg, char* op2_reg);
void mul(char* result_reg, char* op1_reg, char* op2_reg);

void move_int(char* target_reg, int value);
void move_reg(char* target_reg, char* source_reg);
void load(char* target_reg, char* mem);
void store(char* mem, char* source_reg);
void push(char* reg);

void cmp_g(char* result_reg, char* op1_reg, char* op2_reg);
void cmp_eq(char* result_reg, char* op1_reg, char* op2_reg);
void cmp_neq(char* result_reg, char* op1_reg, char* op2_reg);


void lbl(char* label);
void jmp_lbl(char* label);
void jmp_if_false(char* reg, char* label);

void call(char* function);

void emit_prelude(int local_size);
void emit_postlude(int nb_arguments, int nb_local_vars);

#endif
