/*****************************************************************************
 *              D: a minimal compiler for educational purpose                *
 ***************************************************************************** 
 *                                                                           *
 * Copyright (c) 2009 Christophe Alias                                       *
 *                                                                           *
 * This program is free software; you can redistribute it and/or modify it   *
 * under the terms of the GNU General Public License as published by the     *
 * Free Software Foundation; either version 2 of the License, or (at your    * 
 * option) any later version.                                                *
 *                                                                           *
 * This program is distributed in the hope that it will be useful, but       *
 * WITHOUT ANY WARRANTY; without even the implied warranty of                *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General  *
 * Public License for more details.                                          *
 *                                                                           *
 * You should have received a copy of the GNU General Public License along   *
 * with this program; if not, write to the Free Software Foundation, Inc.,   *
 * 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.                 *
 *                                                                           *
 * Written by Christophe Alias, Christophe.Alias@ens-lyon.fr                 *
 *                                                                           *
 *****************************************************************************/
#ifndef __SYMBOL_TABLE_H
#define __SYMBOL_TABLE_H

#define MAX_SYMBOLS 100

int nb_arguments;
char* argument[MAX_SYMBOLS];
char* argument_register[MAX_SYMBOLS];

int nb_local_vars;
char* local_var[MAX_SYMBOLS];
char* local_var_register[MAX_SYMBOLS];

//Constructors
void reset_symbols();
void add_argument(char* id);
void add_local_var(char* id);

//Translation utilities
char* get_register(char* id);
char* get_address(char* id);
void emit_load();  //prelude stack to register
void emit_store(); //postlude register to stack

//Pretty-printer
void print_symbols();

#endif

